/*************************************************
 * gestion de l'affichage et du clavier
 *************************************************/

/* delai d'affichage total */

#define DELAYAFFTOT 25

#define DELAYAFF 50

#define DELAY(d) MOVACC((d)) ; movr 0 ; CLC ; movi 0 ; subr 0 ; movi 16-5 ; jnz         
 
#define SCANKBD(n) \
	mova KBD ; \
	movr 3 ; \
	MOVACC($FF) ; \
	xorr 3 ; \
	JNZ(clav##n) ; \
	LDMEM(3,col##n) ; \
	JZ(clav##n); \
	JMP(fin_affichage) ; \
clav##n: \
	STMEM(3,col##n);


affichage:

	SAVERET(0)

  MOVADR(col0)
	movi 0
	stmem
  MOVADR(col1)
	movi 0
	stmem
  MOVADR(col2)
	movi 0
	stmem
  MOVADR(col3)
	movi 0
	stmem

affichage_loop:
	
  /* aff 0 */
	LDMEM(AFFLED,aff0)
	MOVACC($01);
	movr AFFSEL
	DELAY(DELAYAFF)

	SCANKBD(0)
	
	/* aff 1 */
  
	LDMEM(AFFLED,aff1)
	MOVACC($02)
	movr AFFSEL
	DELAY(DELAYAFF)
	
	SCANKBD(1)

	/* aff 2 */
  
	LDMEM(AFFLED,aff2)
	MOVACC($04)
	movr AFFSEL
	DELAY(DELAYAFF)

	SCANKBD(2)

  /* aff 3 */
	
  LDMEM(AFFLED,aff3)
	MOVACC($08)
	movr AFFSEL
	DELAY(DELAYAFF)

  SCANKBD(3)

  /* aff 4 */

  LDMEM(AFFLED,aff4)
	MOVACC($10)
	movr AFFSEL
	DELAY(DELAYAFF)

  /* aff 5 */

  LDMEM(AFFLED,aff5)
	MOVACC($20)
	movr AFFSEL
	DELAY(DELAYAFF)

  JMP(affichage_loop)

fin_affichage:

	movi 0
	movr AFFSEL

	RET(0)


/*
 * Affichage d'un message pendant un temps ncessaire  la lecture 
 */

affichage_delai:

	SAVERET(0)

	MOVACC(DELAYAFFTOT)
	movr 2

affichage_dloop:
	
  /* aff 0 */
	LDMEM(AFFLED,aff0)
	MOVACC($01);
	movr AFFSEL
	DELAY(DELAYAFF)

	/* aff 1 */
  
	LDMEM(AFFLED,aff1)
	MOVACC($02)
	movr AFFSEL
	DELAY(DELAYAFF)
	
	/* aff 2 */
  
	LDMEM(AFFLED,aff2)
	MOVACC($04)
	movr AFFSEL
	DELAY(DELAYAFF)

  /* aff 3 */
	
  LDMEM(AFFLED,aff3)
	MOVACC($08)
	movr AFFSEL
	DELAY(DELAYAFF)

  /* aff 4 */

  LDMEM(AFFLED,aff4)
	MOVACC($10)
	movr AFFSEL
	DELAY(DELAYAFF)

  /* aff 5 */

  LDMEM(AFFLED,aff5)
	MOVACC($20)
	movr AFFSEL
	DELAY(DELAYAFF)

	CLC
	movi $F
	addr 2
	JNZ(affichage_dloop)

	movi 0
	movr AFFSEL

	RET(0)

col0:
  db 0
col1:
  db 0
col2:
  db 0
col3:
  db 0


aff0:
	db $FF
aff1:
	db $FF
aff2:
	db $FF
aff3:
	db $FF
aff4:
	db $FF
aff5:
	db $FF



/**************************************************
 * Dcodage des codes clavier
 * retour dans "touche"
 **************************************************/
 
convert_key:
	SAVERET(0)

  LDMEM(3,col0)
	JZ(key_1)
  MOVADR(tab_key_0)
  CLC
  JNC(key_10)
key_1:
  LDMEM(3,col1)
	JZ(key_2)
  MOVADR(tab_key_1)
  CLC
  JNC(key_10)
key_2:
  LDMEM(3,col2)
	JZ(key_3)
  MOVADR(tab_key_2)
  CLC
  JNC(key_10)
key_3:
  LDMEM(3,col3)
  MOVADR(tab_key_3)
key_10:
	CLC
	mova 3
	addr 0
	movi 0
	addr 1
	ldmem
	movr 3
	STMEM(3,touche)

	RET(0)
	
	
touche:
 db 0
tab_key_0:
 db 0
 db $1
 db $4
 db 0
 db $7
 db 0
 db 0
 db 0
 db $0

tab_key_1: 
 db 0
 db $2
 db $5
 db 0
 db $8
 db 0
 db 0
 db 0
 db $F
 
tab_key_2:
 db 0
 db $3
 db $6
 db 0
 db $9
 db 0
 db 0
 db 0
 db $E
 
tab_key_3: 
 db 0
 db $A
 db $B
 db 0
 db $C
 db 0
 db 0
 db 0
 db $D

